diff -urN ssh-1.0.fix-bugs/ssh_transport.erl ssh-1.0.fix-connectopt/ssh_transport.erl
--- ssh-1.0.fix-bugs/ssh_transport.erl	2008-09-25 10:49:08.761243000 +0900
+++ ssh-1.0.fix-connectopt/ssh_transport.erl	2008-09-24 19:45:30.029031000 +0900
@@ -145,11 +145,37 @@
     (Ssh#ssh.io_cb):yes_no(Prompt).
 
 
+%% (from gen_tcp)
+mod() -> undefined.
+
+%% Get the tcp_module, but option tcp_module|inet|inet6 overrides
+mod([{tcp_module,Mod}|_]) ->
+    {tcp_module, Mod};
+mod([inet|_]) ->
+    inet_tcp;
+mod([inet6|_]) ->
+    inet6_tcp;
+mod([_|Opts]) ->
+    mod(Opts);
+mod([]) ->
+    mod().
+
 connect(ConnectionSup, Address, Port, SocketOpts, Opts) ->    
     Timeout = proplists:get_value(timeout, Opts, ?DEFAULT_TIMEOUT),
     {_, Callback, _} =  
 	proplists:get_value(transport, Opts, {tcp, gen_tcp, tcp_closed}),
-    case Callback:connect(Address, Port, [{active, false} | SocketOpts], 
+    Mod = mod(SocketOpts),
+    SocketOpts2 = case Mod of
+    undefined ->
+      case Address of
+      {_, _, _, _}             -> [inet  | SocketOpts];
+      {_, _, _, _, _, _, _, _} -> [inet6 | SocketOpts];
+      _UnknownAddressFamily    -> SocketOpts
+      end;
+    Specified -> [ Specified | SocketOpts ]
+    end,
+
+    case Callback:connect(Address, Port, [{active, false} | SocketOpts2], 
 			 Timeout) of
  	{ok, Socket} ->
 	    {ok, Pid} = 
